// COPYRIGHT (c) 2002 PLOTNIX, INC. All rights reserved

package com.plotnix.jex;

import java.util.Iterator;

/**
 * Compiled form of an iteration expression, which can be evaluated in
 * a {@link Context Context}.
 *
 * @author Dmitri Plotnikov
 * @version $Revision$ $Date$
 */
public interface IterationExpression {
    
    /**
     * Produces the iterator described by the expression in the
     * specified context with the supplied arguments.
     * 
     * @param context is an evaluation context.
     * @param arguments are argument of the expression. Can be null
     *  if the expression does not take any arguments.
     * @return the result of the evaluation of this expression
     */
    Iterator iterate(Context context, Object[] arguments);
}
