// COPYRIGHT (c) 2002 PLOTNIX, INC. All rights reserved

package com.plotnix.jex;

/**
 * Compiled form of a left-hand side expression, which can be assigned
 * a value.
 *
 * @author Dmitri Plotnikov
 * @version $Revision$ $Date$
 */
public interface VariableExpression {
    
    /**
     * Modifies a value in the specified context according to the
     * expression and the supplied arguments.  Casts the type of 
     * the value if necessary.
     * 
     * @param context is an evaluation context.
     * @param value is the new value
     * @param arguments are argument of the expression. Can be null
     *  if the expression does not take any arguments.
     */
    void assign(Context context, Object value, Object[] arguments);    

}
