package com.plotnix.jex.javascript;

import java.util.Iterator;

import org.mozilla.javascript.JavaScriptException;
import org.mozilla.javascript.Script;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.Wrapper;

import com.plotnix.jex.Context;
import com.plotnix.jex.IterationExpression;
import com.plotnix.jex.util.ValueUtils;

/**
 * 
 *
 * @author Dmitri Plotnikov
 * @version $Revision$ $Date$
 */
public class JavaScriptIterationExpression extends JavaScriptExpression
    implements IterationExpression {

    /**
     * @param script is a compiled JavaScript to be associated with
     *  this expression
     */
    public JavaScriptIterationExpression(Script script){
        super(script);
    }
    
    /**
     * @see IterationExpression#iterate(Context, Object[])
     */
    public Iterator iterate(Context context, Object[] arguments) {
        Object result = null;
        org.mozilla.javascript.Context jsContext = 
                org.mozilla.javascript.Context.enter();
        try {
            Scriptable scope = getLocalScope(context, jsContext, arguments);
            result = getScript().exec(jsContext, scope);
            if (result instanceof Wrapper){
                result = ((Wrapper) result).unwrap();
            }
        }
        catch (JavaScriptException ex){
            ex.printStackTrace();
        }
        org.mozilla.javascript.Context.exit();
        return ValueUtils.iterate(result);
    }
}
