package com.plotnix.jex.javascript;

import org.mozilla.javascript.JavaScriptException;
import org.mozilla.javascript.Script;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.Wrapper;

import com.plotnix.jex.Context;
import com.plotnix.jex.Expression;
import com.plotnix.jex.util.TypeUtils;

/**
 * 
 *
 * @author Dmitri Plotnikov
 * @version $Revision$ $Date$
 */
public class JavaScriptValueExpression extends JavaScriptExpression
    implements Expression {
        
    /**
     * @param script is a compiled JavaScript to be associated with
     *  this expression
     */
    public JavaScriptValueExpression(Script script){
        super(script);
    }

    /**
     * @see Expression#evaluate(Context, Object[])
     */
    public Object evaluate(Context context, Object[] arguments) {        
        Object result = null;
        org.mozilla.javascript.Context jsContext = 
                org.mozilla.javascript.Context.enter();
        try {
            Scriptable scope = getLocalScope(context, jsContext, arguments);
            result = getScript().exec(jsContext, scope);
            if (result instanceof Wrapper){
                result = ((Wrapper) result).unwrap();
            }
        }
        catch (JavaScriptException ex){
            ex.printStackTrace();
        }
        org.mozilla.javascript.Context.exit();
        return result;
    }

    /**
     * @see Expression#evaluate(Context, Object[], Class)
     */
    public Object evaluate(Context context, 
            Object[] arguments, Class valueType){
        Object result = evaluate(context, arguments);
        if (!TypeUtils.canConvert(result, valueType)){
            throw new RuntimeException("Cannot convert " + result + " to " +
                valueType);
        }        
        return TypeUtils.convert(result, valueType);
    }

}
