package com.plotnix.jex.javascript;

import org.mozilla.javascript.JavaScriptException;
import org.mozilla.javascript.Script;
import org.mozilla.javascript.Scriptable;

import com.plotnix.jex.Context;
import com.plotnix.jex.VariableExpression;

/**
 * 
 *
 * @author Dmitri Plotnikov
 * @version $Revision$ $Date$
 */
public class JavaScriptVariableExpression extends JavaScriptExpression
    implements VariableExpression {

    /**
     * @param script is a compiled JavaScript to be associated with
     *  this expression
     */
    public JavaScriptVariableExpression(Script script){
        super(script);
    }

    /**
     * @see VariableExpression#assign(Context, Object, Object[])
     */
    public void assign(Context context, Object value, Object[] arguments) {
        Object result = null;
        org.mozilla.javascript.Context jsContext = 
                org.mozilla.javascript.Context.enter();
        try {
            Scriptable scope = 
                getLocalScope(context, jsContext, arguments, value);
            getScript().exec(jsContext, scope);
        }
        catch (JavaScriptException ex){
            ex.printStackTrace();
        }
        org.mozilla.javascript.Context.exit();
    }
}
